#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define MAX_STR 30
#define MAX_NUMERO 6

typedef struct {
    char nomeDip[MAX_STR+1];
    int occorrenze[MAX_NUMERO];
} stat;


stat vett[2] = {
    {"ACQUISTI", {0,0,0,0,0,0}},
    {"VENDITE", {0,0,0,0,0,0}},
    };

void riempi_vett(char nomefile[], stat vett[], int lungVett);
void toner_statistic(stat vett[], int lungVett);

int main() {
    riempi_vett("files/es3.txt", vett, 2);

    for (int i=0; i<2; i++) {
        printf("%s, {%d %d %d %d %d %d}\n", vett[i].nomeDip, 
                vett[i].occorrenze[0], vett[i].occorrenze[1],
                vett[i].occorrenze[2], vett[i].occorrenze[3],
                vett[i].occorrenze[4], vett[i].occorrenze[5]);
    }

    toner_statistic(vett, 2);
}

void riempi_vett(char nomefile[], stat vett[], int lungVett) {
    FILE *f = fopen(nomefile, "r");

    char nome[MAX_STR+1];
    int qty;

    if (f == NULL) {
        perror("Errore apertura file\n");
        exit(-1);
    }

    while (fscanf(f, "%s %d", nome, &qty) == 2) {
        for (int i=0; i<lungVett; i++) {
            if (strcmp(nome, vett[i].nomeDip) == 0) {
                vett[i].occorrenze[qty-1]++;
            }
        }
    }

    fclose(f);
}

void toner_statistic(stat vett[], int lungVett) {
    FILE *f = fopen("statistiche.txt", "w");

    int min, max, moda, cnt, sum;

    float avg;

    if (f == NULL) {
        perror("Errore apertura file\n");
        exit(-1);
    }

    for (int i=0; i<lungVett; i++) {
        min = -1;
        max = -1;

        sum = 0;
        cnt = 0;

        moda = 0; 

        for (int j=0; j<MAX_NUMERO; j++) {
            // min and max
            if (vett[i].occorrenze[j] != 0) {
                max = j+1;
                if (min == -1) {
                    min = j+1;
                }
            }

            // avg
            sum += (j+1) * vett[i].occorrenze[j];
            cnt += vett[i].occorrenze[j];

            // moda
            if (vett[i].occorrenze[j] > vett[i].occorrenze[moda]) {
                moda = j;
            }
        }

        avg = ((float) sum) / ((float) cnt);

        if (max == -1) { // non abbiamo trovato nessun ordine
            fprintf(f, "%s Il dip. non ha ordinato toner\n", vett[i].nomeDip);
        }
        else {
            fprintf(f, "%s %d, %d, %f, (%d, %d)\n", vett[i].nomeDip, min, max, avg, moda+1, vett[i].occorrenze[moda]);
        }
    }
}