#include <stdio.h>
#include <stdlib.h>

#define NUM_GIUDICI 5
#define MAX_STRING 30

typedef struct {
  char nome[MAX_STRING + 1];
  char cognome[MAX_STRING + 1];
  char sesso;
  char nazione[MAX_STRING + 1];
  float punteggi[NUM_GIUDICI];
  float gradoDifficolta;
} atleta_t;

typedef struct {
  atleta_t *array;
  int numAtleti;
} gara_t;

gara_t acquisisciDaFile(char nomefile[]) {
    FILE *f = fopen(nomefile, "r");

    char nome[MAX_STRING+1];
    char cognome[MAX_STRING+1];
    char sesso;
    char nazione[MAX_STRING+1];
    float punteggi[NUM_GIUDICI];
    float difficolta;

    gara_t res;

    int i = 0;

    res.numAtleti = 0;

    while (fscanf(f, "%s %s %c %s %f %f %f %f %f %f\n", nome, cognome, &sesso, nazione, 
                &punteggi[0], &punteggi[1], &punteggi[2], 
                &punteggi[3], &punteggi[4], &difficolta) == 10) {
        res.numAtleti++;
    }

    rewind(f);

    res.array = malloc(sizeof(atleta_t) * res.numAtleti);

    while (fscanf(f, "%s %s %c %s %f %f %f %f %f %f\n", res.array[i].nome, res.array[i].cognome, &res.array[i].sesso, res.array[i].nazione, 
                &res.array[i].punteggi[0], &res.array[i].punteggi[1], &res.array[i].punteggi[2], 
                &res.array[i].punteggi[3], &res.array[i].punteggi[4], &res.array[i].gradoDifficolta) == 10) {
        i++;
    }

    return res;
}

void stampa_migliori(gara_t g) {
    float migliore = 0.0;
    int idx_migliore;

    float min, max;
    
    float curr; 

    for (int i=0; i<g.numAtleti; i++) {
        curr = 0.0;
        min = 10.0;
        max = 0.0;
        printf("%d\n", i);
        for (int j=0; j<5; j++) {
            curr += g.array[i].punteggi[j];
            if (g.array[i].punteggi[j] < min) min = g.array[i].punteggi[j];
            if (g.array[i].punteggi[j] > max) max = g.array[i].punteggi[j];
        }

        curr = (curr - min - max) * g.array[i].gradoDifficolta;
        
        if (curr > migliore) {
            migliore = curr; 
            idx_migliore = i;
        }
    }

    printf("%s %s\n", g.array[idx_migliore].nome, g.array[idx_migliore].cognome);
}

int main() {
    gara_t gara = acquisisciDaFile("files/es6.txt");

    // stampa la gara acquisita da file
    /* for (int i = 0; i<gara.numAtleti; i++) {
        printf("%s %s %c %s %f %f %f %f %f %f\n", gara.array[i].nome, gara.array[i].cognome, gara.array[i].sesso, gara.array[i].nazione, gara.array[i].punteggi[0], gara.array[i].punteggi[1], gara.array[i].punteggi[2], gara.array[i].punteggi[3], gara.array[i].punteggi[4], gara.array[i].gradoDifficolta);
    } */

   stampa_migliori(gara);
}